package yonsei.insight;

import java.awt.AWTException;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.net.ServerSocket;
import java.net.Socket;

/***********************************
 * 
 * MICSQ Server v1.0 (2013.10.20 Relesed)
 * T. Kim (enoughrice21@yonsei.ac.kr) and J. Kang (jwkang@yonsei.ac.kr)
 *
 ***********************************/

public class MICSQServer {
	static int serverPort = 10004;
	final static String DIR_PATH = "C:\\MICSQ\\";
	static int iInterval, iNumVideo, iNumStart;;
	static int[] iPlayTime;
	static double fStartScore;
	static boolean bError=false;
	
	public static void main(String[] args) {
		try {
			// Open the File
			File mFile;
			File mFileVote;
			File mDir;
			int nDVote;
			String[] dVote = null;
			String[] dVoteTitle = null;
			
			if (args.length != 0)
				serverPort = Integer.parseInt(args[0]);
			
			if (!(mFile = new File(DIR_PATH + "setup.txt")).exists()) {
				System.out.println("The \""+DIR_PATH + "setup.txt"+"\" File does not exists.");
				return;
			}
			
			if (!(mFileVote = new File(DIR_PATH + "setupVote.txt")).exists()) {
				nDVote = 0;
				dVote = null;
			} else {
				Reader mReader = new FileReader(mFileVote);
				BufferedReader mBReader = new BufferedReader(mReader);
				nDVote = Integer.parseInt(mBReader.readLine());
				if (nDVote > 0) {
					dVoteTitle = new String[nDVote];
					dVote = new String[nDVote*5];
					
					for (int i=0; i<nDVote; i++) {
						dVoteTitle[i] = mBReader.readLine();
						for (int j=0; j<5; j++) {
							dVote[i*5+j] = mBReader.readLine();
						}
					}
					mBReader.close();
					mReader.close();
				} else {
					nDVote = 0;
				}
			}
			
			Reader mReader = new FileReader(mFile);
			BufferedReader mBReader = new BufferedReader(mReader);
			
			iNumStart = 1;
			iInterval = Integer.parseInt(mBReader.readLine());
			fStartScore = Float.parseFloat(mBReader.readLine());
			iNumVideo = Integer.parseInt(mBReader.readLine());
			iPlayTime = new int[iNumVideo];
			
			for (int i=iNumStart-1; i<iNumVideo; i++)
				iPlayTime[i] = Integer.parseInt(mBReader.readLine());
			
			mBReader.close();
			mReader.close();
			
			ServerSocket mServerSocket = new ServerSocket(serverPort);
			
			System.out.println("Waiting Client...");
			Socket mSocket = mServerSocket.accept();
			
			System.out.println("Client Connected.");
			OutputStream mOut = mSocket.getOutputStream();
			InputStream mIn = mSocket.getInputStream();
			Robot mRobot = new Robot();
			mRobot.keyPress(KeyEvent.VK_O);
			
			PrintWriter mPW = new PrintWriter(new OutputStreamWriter(mOut));
			BufferedReader mBR = new BufferedReader(new InputStreamReader(mIn));
			
			String sLine = null;
			
			
			
			// Send the interval to client
			mPW.println(iInterval);
			// Send Start Location
			mPW.println(fStartScore);
			mPW.flush();
			
			int iFileNum = 0;
			while ((mDir = (new File(DIR_PATH + "data"+(++iFileNum)))).exists());
			
			mDir.mkdir();
			
			
			for (int i=0; i<iNumVideo; i++) {
				// Open the File
				System.out.println("\n"+(i+1)+"th Movie\n");

	    		//if (!mDir.exists())
				
				mFile = new File(mDir.getAbsolutePath() + "/" + (i+1) + ".txt");
				
				Writer mWriter = new FileWriter(mFile);
				BufferedWriter mFileOut = new BufferedWriter(mWriter);
				
				
				// DeterMine Ends
				mPW.println("OK");
				mPW.flush();

				// "COUNT" message comes
				do {
					sLine = mBR.readLine();
				} while (!sLine.equals("COUNT"));

				System.out.println("Message : " + sLine);
				System.out.println("\nCounting Process Start!");
				
				// Send Playing Time
				mPW.println(iPlayTime[i]);
				mPW.flush();
	
				// "COUNT" message comes
				do {
					sLine = mBR.readLine();
				} while (!sLine.equals("START"));
				
				mRobot.keyPress(KeyEvent.VK_P);
				System.out.println("Message : " + sLine);
				System.out.println("Start!");
				
				// Video start
				
				
				if (bError)
					bError = false;
					
				
				// Recording
				while (true) {
					// Get Time (long)
					sLine = mBR.readLine();
					if (sLine.equals("ERROR")) {
						System.out.println("\nThe Vote is Finished Incompletely.");
						bError = true;
						mRobot.keyPress(KeyEvent.VK_R);
						break;
					}
					
					if (sLine.equals("FINISH")) {
						System.out.println("\nThe Continuous Vote is Finished Completely.");
						mRobot.keyPress(KeyEvent.VK_N);
						
						if (nDVote > 0) {
							mPW.println("DVOTE");
							mPW.flush();
							System.out.println("\nThe Discrete Vote Start");
							mPW.println(nDVote);
							
							for (int j=0; j<nDVote; j++) {
								mPW.println(dVoteTitle[j]);
								System.out.println(dVoteTitle[j]);
							}
								
							for (int j=0; j<nDVote*5; j++) {
								mPW.println(dVote[j]);
							}
							
							mPW.flush();
							
							mFileVote = new File(mDir.getAbsolutePath() + "/Vote-" + (i+1) + ".txt");
							Writer mVoteWriter = new FileWriter(mFileVote);
							BufferedWriter mFileVoteOut = new BufferedWriter(mVoteWriter);
							
							for (int j=0; j<nDVote; j++) {
								int value = Integer.parseInt(mBR.readLine());
								System.out.println((j+1)+"th Discrete Vote - "+(value / 10.0));
								mFileVoteOut.write((value / 10.0)+"\n");
								mPW.flush();
							}
							
							mFileVoteOut.flush();
							mFileVoteOut.close();
							
							System.out.println("\nThe Discrete Vote is Finished Completely.");
						} else {
							mPW.println("NOTDVOTE");
						}
						
						break;
					}
					

					// Get Score (float)
					sLine = mBR.readLine();
					
					mFileOut.write(sLine);
					mFileOut.newLine();
					
					mPW.flush();
				}
				
				mFileOut.flush();
				mFileOut.close();
				
				if (bError) {
					mFile.delete();
					i--;
				}
			}
			
			mPW.println("CLOSE");
			
			mPW.close();
			mBR.close();
			
			mSocket.close();
			mServerSocket.close();
			
			System.out.println("\nThe Program is finished.");
			return;
		
		} catch (IOException e) {
			e.printStackTrace();
		} catch (AWTException e) {
			e.printStackTrace();
		} 
	}
}
